from django import forms

from webservice_running.models import OrdersLocal 


class OrderRegForm(forms.ModelForm):
    class Meta: 
        model = OrdersLocal
        fields = '__all__'

    def __init__(self, *args, **kwargs):
      super().__init__(*args, **kwargs)
      for field in self.fields.values():
          field.widget.attrs['class'] = 'form-control'
