import requests
import xmpp
from xmpp import cli
import config
from BotClass import JabberBot
import json
#раскомментировать, когда перейдем на разные пароли
import hashlib
from datetime import datetime

import time
import threading

#test
import jsonAndRequest as jsreq


global tasklist



botname="open_servicerequest_booked"
##############################
# operating_status='211'
# JID=botname+"@"+config.JSERVER
# PORT=config.PORT

# PASSWORD=hashlib.md5((botname+config.PASSWORD).encode('utf-8')).hexdigest()




###################
botname="open_servicerequest_closed"

operating_status=239
JID=botname+"@"+config.JSERVER
PORT=config.PORT

PASSWORD=hashlib.md5((botname+config.PASSWORD).encode('utf-8')).hexdigest()

print(JID, PASSWORD)

token = jsreq.requestGetToken(botname, PASSWORD, config.API_URL+"my/api/v1/auth/token/login/")
headers = {'Authorization': f'Token {token}'}


#таким образом хранится список jid, от которых можно получать сообщения этому боту
listen_to=["799999999990@ej.sharix-app.org","test@ej.sharix-app.org"]

#тут хранится список jid, кому бот может отправлять сообщения в результате обработки заявки
proceed_to=[botname, "open_strequest_new@ej.sharix-app.org", "open_servicerequest_closed@ej.sharix-app.org", "open_servicerequest_forcemajeure@ej.sharix-app.org"]

#максимальное значение попыток обработать заказ
idle_value=10

def log_handler():
    while True:
        with open(f'{botname}.txt', 'a') as log_file:
            log_file.write(f"{time.strftime('%Y-%m-%d %H:%M:%S')} - {botname} is still running...\n")
        time.sleep(3600)


# обработчик входящих сообщений
def message_handler(conn, mess):
    text = mess.getBody()#текст сообщения боту
    user = mess.getFrom()#отправитель сообщения
    if (str(user).split("/")[0]) in listen_to:
        if text is not None:
            orderObj = jsreq.jsonToOrder(text)
            tasklist.append(orderObj)
            bot.bot_log(str(datetime.now())+" Поступивший заказ успешно добавлен в очередь обработки\n")

def open_servicerequest_closed_wait(period,localtask):
    bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ ожидает\n")
    time.sleep(period)
    
    #ВАЖНО! Надо скорее всего через API редактировать заказ, иначе возможна потеря данных
    localtask.title=localtask.title+"1"

    #обязательно данный обработчик должен заканчиваться передачей заказа куда-то на обработку дальше - обратно или другому, иначе оно потеряется
    bot.proceed_status(proceed_to[0],localtask)
    bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ подождал и отправлен в очередь\n")

def open_servicerequest_closed_process(localtask):
    bot.bot_log(botname + " " + str(datetime.now()) + " " + "Заказ в обработчике\n")
    response = requests.delete(config.API_URL+f"/dbsynce/api/orders/{localtask.id}/",headers=headers)
    text = (config.API_URL+f"dbsynce/api/orders/{localtask.id}/")
    if response:      
        bot.proceed_status(proceed_to[2],localtask)
        bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ удален\n")
    else:
        bot.proceed_status(proceed_to[-1],localtask)
        bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ не по адресу, перенаправляем на форсмажор\n")



def open_servicerequest_closed():
    log_thread = threading.Thread(target=log_handler)
    log_thread.daemon = True 
    log_thread.start()
    while (len(tasklist)):
        localtask=tasklist.pop(0)
        bot.bot_log(botname + " " + datetime.now().strftime('%Y-%m-%d') + " "+ "Заказ в очереди на обработке\n")
        # if (localtask.status!=operating_status):
        #     bot.proceed_status(proceed_to[-1],localtask)
        #     bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ не по адресу, перенаправляем на форсмажор\n")
        #     continue

        # if (localtask.title!="10"):
        #     t1=threading.Thread(target=open_servicerequest_booked_wait, args=(5,localtask))
        #     t1.start()

        if (localtask.status in ("239","211","212","220","221","222","231","238","229")):
            t1=threading.Thread(target=open_servicerequest_closed_process, args=([localtask]))
            t1.start()


        #если никакие обработчики не подошли - отправляем обратно в очередь
        bot.proceed_status(proceed_to[0],localtask)
        print("Заказ возвращен в очередь\n")

#Авторизация и запуск бота

#пустой список заказов
tasklist = []

#надо инициализировать tasklist при запуске из API
token = jsreq.requestGetToken(botname, PASSWORD, config.API_URL+"my/api/v1/auth/token/login/")
#ВАЖНО! Надо еще фильтровать список по статусу обработки заявки
tasklist_dbsynce=jsreq.requestGetList(token, config.API_URL+"/dbsynce/api/orders/")

bot = JabberBot(JID, PASSWORD, PORT)

bot.register_handler('message', message_handler)
bot.start(open_servicerequest_closed)